(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/internal/BehaviorSubject'), require('rxjs'), require('@angular/router'), require('rxjs/internal/Subscription'), require('rxjs/operators'), require('util'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-neocrumb', ['exports', '@angular/core', 'rxjs/internal/BehaviorSubject', 'rxjs', '@angular/router', 'rxjs/internal/Subscription', 'rxjs/operators', 'util', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-neocrumb'] = {}, global.ng.core, global.rxjs['internal/BehaviorSubject'], global.rxjs, global.ng.router, global.rxjs['internal/Subscription'], global.rxjs.operators, global.util, global.ng.common));
}(this, function (exports, core, BehaviorSubject, rxjs, router, Subscription, operators, util, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NeoCrumbService = /** @class */ (function () {
        function NeoCrumbService() {
            this.change$ = new BehaviorSubject.BehaviorSubject([]);
            this.postProcess$ = new rxjs.Subject();
        }
        /**
         * @param {?} data
         * @return {?}
         */
        NeoCrumbService.prototype.postProcess = /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.postProcess$.next(data);
        };
        /**
         * @param {?} data
         * @return {?}
         */
        NeoCrumbService.prototype.change = /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.change$.next(data);
        };
        Object.defineProperty(NeoCrumbService.prototype, "onPostProcess", {
            get: /**
             * @return {?}
             */
            function () {
                var _this = this;
                return new rxjs.Observable((/**
                 * @param {?} fn
                 * @return {?}
                 */
                function (fn) { return _this.postProcess$.subscribe(fn); }));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NeoCrumbService.prototype, "onChange", {
            get: /**
             * @return {?}
             */
            function () {
                var _this = this;
                return new rxjs.Observable((/**
                 * @param {?} fn
                 * @return {?}
                 */
                function (fn) { return _this.change$.subscribe(fn); }));
            },
            enumerable: true,
            configurable: true
        });
        NeoCrumbService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NeoCrumbService.ctorParameters = function () { return []; };
        /** @nocollapse */ NeoCrumbService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NeoCrumbService_Factory() { return new NeoCrumbService(); }, token: NeoCrumbService, providedIn: "root" });
        return NeoCrumbService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        NeoCrumbService.prototype.change$;
        /**
         * @type {?}
         * @private
         */
        NeoCrumbService.prototype.postProcess$;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NeoCrumbComponent = /** @class */ (function () {
        function NeoCrumbComponent(router, activatedRoute, neoCrumbService) {
            this.router = router;
            this.activatedRoute = activatedRoute;
            this.neoCrumbService = neoCrumbService;
            this.routeLinks = [];
            this.subscriptions = new Subscription.Subscription();
        }
        /**
         * @return {?}
         */
        NeoCrumbComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.routeLinks = this.createBreadcrumbs(this.activatedRoute.root);
            /** @type {?} */
            var postProcessSubscription = this.neoCrumbService.onPostProcess
                .subscribe((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return _this.routeLinks = value; }));
            /** @type {?} */
            var routerEventsSubscription = this.router.events
                .pipe(operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event instanceof router.NavigationEnd; })))
                .subscribe((/**
             * @return {?}
             */
            function () { return _this.routeLinks = _this.createBreadcrumbs(_this.activatedRoute.root); }));
            this.subscriptions.add(routerEventsSubscription);
            this.subscriptions.add(postProcessSubscription);
        };
        /**
         * @private
         * @param {?} route
         * @param {?=} url
         * @param {?=} breadcrumbs
         * @return {?}
         */
        NeoCrumbComponent.prototype.createBreadcrumbs = /**
         * @private
         * @param {?} route
         * @param {?=} url
         * @param {?=} breadcrumbs
         * @return {?}
         */
        function (route, url, breadcrumbs) {
            var e_1, _a;
            if (url === void 0) { url = ''; }
            if (breadcrumbs === void 0) { breadcrumbs = []; }
            /** @type {?} */
            var children = route.children;
            if (children.length === 0) {
                this.neoCrumbService.change(breadcrumbs);
                return breadcrumbs;
            }
            try {
                for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                    var child = children_1_1.value;
                    /** @type {?} */
                    var routeURL = this.getRouteUrl(child.snapshot.url);
                    /** @type {?} */
                    var breadcrumb = child.snapshot.data['breadcrumb'];
                    if (routeURL !== '') {
                        url += "/" + routeURL;
                    }
                    if (!util.isNullOrUndefined(breadcrumb) && !(routeURL === '' && child.children.length < 1))
                        breadcrumbs.push({ text: breadcrumb.text, link: url, iconClass: breadcrumb.iconClass, hide: breadcrumb.hide });
                    return this.createBreadcrumbs(child, url, breadcrumbs);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        /**
         * @param {?} segment
         * @return {?}
         */
        NeoCrumbComponent.prototype.getRouteUrl = /**
         * @param {?} segment
         * @return {?}
         */
        function (segment) {
            return segment.map((/**
             * @param {?} seg
             * @return {?}
             */
            function (seg) { return seg.path; })).join('/');
        };
        /**
         * @param {?} index
         * @return {?}
         */
        NeoCrumbComponent.prototype.isActive = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return index == this.routeLinks.length - 1;
        };
        /**
         * @return {?}
         */
        NeoCrumbComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.subscriptions.unsubscribe();
        };
        NeoCrumbComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nc-neo-crumb',
                        template: "<nav aria-label=\"breadcrumb\" *ngIf=\"routeLinks && routeLinks.length && !routeLinks[routeLinks.length -1].hide\">\r\n\t<ol class=\"neo-breadcrumb\" [class.d-inline-block]=\"inlineBlock\">\r\n\t\t<ng-container *ngFor=\"let routeLink of routeLinks; let i = index\">\r\n\t\t\t<li class=\"neo-breadcrumb-item\" *ngIf=\"!isActive(i)\">\r\n\t\t\t\t<a [routerLink]=\"[routeLink.link]\">\r\n\t\t\t\t\t<i *ngIf=\"routeLink.iconClass\" [classList]=\"routeLink.iconClass\"></i>\r\n\t\t\t\t\t{{routeLink.text}}\r\n\t\t\t\t</a>\r\n\t\t\t</li>\r\n\t\t\t<li class=\"neo-breadcrumb-item active\" *ngIf=\"isActive(i)\">\r\n\t\t\t\t<i *ngIf=\"routeLink.iconClass\" [classList]=\"routeLink.iconClass\"></i>\r\n\t\t\t\t{{routeLink.text}}\r\n\t\t\t</li>\r\n\t\t</ng-container>\r\n\t</ol>\r\n</nav>\r\n"
                    }] }
        ];
        /** @nocollapse */
        NeoCrumbComponent.ctorParameters = function () { return [
            { type: router.Router },
            { type: router.ActivatedRoute },
            { type: NeoCrumbService }
        ]; };
        NeoCrumbComponent.propDecorators = {
            inlineBlock: [{ type: core.Input }]
        };
        return NeoCrumbComponent;
    }());
    if (false) {
        /** @type {?} */
        NeoCrumbComponent.prototype.inlineBlock;
        /** @type {?} */
        NeoCrumbComponent.prototype.routeLinks;
        /** @type {?} */
        NeoCrumbComponent.prototype.subscriptions;
        /**
         * @type {?}
         * @private
         */
        NeoCrumbComponent.prototype.router;
        /**
         * @type {?}
         * @private
         */
        NeoCrumbComponent.prototype.activatedRoute;
        /**
         * @type {?}
         * @private
         */
        NeoCrumbComponent.prototype.neoCrumbService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function RouteLink() { }
    if (false) {
        /** @type {?} */
        RouteLink.prototype.text;
        /** @type {?} */
        RouteLink.prototype.link;
        /** @type {?|undefined} */
        RouteLink.prototype.iconClass;
        /** @type {?|undefined} */
        RouteLink.prototype.hide;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NeoCrumbModule = /** @class */ (function () {
        function NeoCrumbModule() {
        }
        /**
         * @return {?}
         */
        NeoCrumbModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: NeoCrumbModule,
            };
        };
        /**
         * @return {?}
         */
        NeoCrumbModule.forChild = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: NeoCrumbModule
            };
        };
        NeoCrumbModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [NeoCrumbComponent],
                        imports: [
                            common.CommonModule,
                            router.RouterModule.forChild([]),
                        ],
                        exports: [NeoCrumbComponent]
                    },] }
        ];
        return NeoCrumbModule;
    }());

    exports.NeoCrumbComponent = NeoCrumbComponent;
    exports.NeoCrumbModule = NeoCrumbModule;
    exports.NeoCrumbService = NeoCrumbService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-neocrumb.umd.js.map
