import { OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute, Router, UrlSegment } from '@angular/router';
import { RouteLink } from '../models/neo-crumb.models';
import { Subscription } from 'rxjs/internal/Subscription';
import { NeoCrumbService } from '../services/neo-crumb.service';
export declare class NeoCrumbComponent implements OnInit, OnDestroy {
    private router;
    private activatedRoute;
    private neoCrumbService;
    inlineBlock: boolean;
    routeLinks: RouteLink[];
    subscriptions: Subscription;
    constructor(router: Router, activatedRoute: ActivatedRoute, neoCrumbService: NeoCrumbService);
    ngOnInit(): void;
    private createBreadcrumbs;
    getRouteUrl(segment: UrlSegment[]): string;
    isActive(index: number): boolean;
    ngOnDestroy(): void;
}
